/*
 * HashFUnctionTemplate.h
 *
 */

#ifndef HASHFUNCTIONTEMPLATE_H_
#define HASHFUNCTIONTEMPLATE_H_

#include <string>

template<typename K>
struct MyHash {
	static size_t compute(K key) {
		return key.hash();
	}
};

template<>
struct MyHash<std::string> {
	static size_t compute(std::string key);
};

size_t MyHash<std::string>::compute(std::string key) {
	size_t hash = 0;
	for (int i = 0; i < key.length(); i++)
	    hash = (31 * hash + key[i]);
	return hash;
}


#endif /* HASHFUNCTIONTEMPLATE_H_ */
